package com.fr.plugin.login;

import com.fr.decision.fun.impl.AbstractLoginTokenProcessor;
import com.fr.decision.privilege.TransmissionTool;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.security.JwtUtils;

import java.util.Map;

/**
 * @author Afly
 * created on 2021-10-09
 */
@FunctionRecorder
public class CustomTokenProcessor extends AbstractLoginTokenProcessor {

    @Override
    public String generateToken(String username, Map<String, Object> extraInfo, long timeout) {
        return JwtUtils.createDefaultJWT(TransmissionTool.defaultEncrypt(username), extraInfo, timeout);
    }

    @Override
    public String getUsername(String token) {
        return TransmissionTool.decrypt(JwtUtils.parseJWT(token).getSubject());
    }

    @Override
    public Map<String, Object> getExtraInfo(String token) {
        return JwtUtils.parseJWT(token);
    }

    @Override
    public boolean checkTokenExpired(String token) {
        return JwtUtils.checkJWTExpired(token);
    }
}
